
  number_of_spaces = 3
  menu_position_x = -60
  menu_position_y = 25
  menu_width_x = 160
  menu_width_y = 4
  
  function bla() end
  function nothing() reaper.defer(bla) end
  
  local str_sep = package.config:sub(1,1)
  local str_win = "\\"
  if str_sep == str_win then
    get_os = "win"
  else
    get_os = "mac"
  end
  
  function Main()
    local filename = reaper.GetResourcePath() .. "\\" .. "reaper.ini"
    local table_proj = {}
    
    for l in io.lines(filename) do
      if string.sub(l,0,6) == "recent" then
        local count = 0
        local count1 = 0
        local count1_bl = false
        local find_number = false
        local string_num = ""
        for s in string.gmatch(l, ".") do
          count = count + 1
          if find_number == false and s == string.match(s,"%d") then
            string_num = string_num .. s
          elseif find_number == false and s == "=" then
            find_number = true
          end
          if s == str_sep then
            if count1_bl == false then
              count1 = count
              count1_bl = true
            end
          end
        end
        if reaper.file_exists(string.sub(l, count1-2, string.len(l))) == true then
          table_proj[#table_proj+1] = { string.sub(l, count1-2, string.len(l)), tonumber(string_num) }
        end
      end
    end
    
    local last_open_project = ""
    local last_open_project_directory = ""
    if last_open_project ~= '' then
      if reaper.file_exists(last_open_project_directory) == false then
        last_open_project = ""
        last_open_project_directory = ""
      end
    end

    table.sort(table_proj, function(a,b) return b[2] < a[2] end)
    
    function remove_duplicates(input_table)
      local hash = {}
      local res = {}
      
      for _,v in ipairs(input_table) do
        if (not hash[v]) then
          res[#res+1] = v
          hash[v] = true
        end
      end
      return res
    end
    
    ----------------------------------------------------------------------------
    local one_table_proj = {}
    
    for i=1, #table_proj do
      one_table_proj[#one_table_proj+1] = table_proj[i][1]
    end
    
    local table_proj = remove_duplicates(one_table_proj)
    ----------------------------------------------------------------------------
    
    local new_table_proj_names = {}
    for i=1, #table_proj do
      local count = 0
      local count1 = 0
      for s in string.gmatch(table_proj[i], ".") do
        count = count + 1
        if s == str_sep then
          count1 = count
        end
      end
      new_table_proj_names[#new_table_proj_names+1] = table_proj[i]:sub(count1+1, table_proj[i]:len()) .. "|"
    end

    if last_open_project ~= "" then
      table.insert(new_table_proj_names, 1, "|#RECENT PROJECTS:||")
      table.insert(new_table_proj_names, 1, last_open_project .. "|")
      table.insert(new_table_proj_names, 1, "#PINNED PROJECT:||   ")
      table.insert(table_proj, 1, "")
      table.insert(table_proj, 1, last_open_project_directory)
      table.insert(table_proj, 1, "")
    end
    
    local retval = gfx.showmenu(table.concat(new_table_proj_names))
    
    if retval == 0 then
      nothing()
    else
      gfx.quit()
      reaper.Main_openProject(table_proj[retval])
      
      if last_open_project_directory == table_proj[retval] then
        nothing()
      else
      
        local _,inputFile,_,_,_,_,_ = reaper.get_action_context()
        
        local file = io.open(inputFile, 'r')
        local fileContent = {}
        local numb_find_1, numb_find_2 = 0, 0
        local bool_find_line_1, bool_find_line_2 = false, false
        local counter_lines = 0
        
        for line in file:lines() do
          counter_lines = counter_lines + 1
          table.insert (fileContent, line)
          if string.find(line, "last_open_project") and bool_find_line_1 == false then
            numb_find_1 = counter_lines
            bool_find_line_1 = true
          elseif string.find(line, "last_open_project_directory") and bool_find_line_2 == false then
            numb_find_2 = counter_lines
            bool_find_line_2 = true
          end
        end
        io.close(file)
        
        fileContent[numb_find_1] = "    local last_open_project = " .. "'" .. 
        new_table_proj_names[retval]:sub(1, new_table_proj_names[retval]:len()-1) .. "'"
        
        local count_j_s = 0
        local new_str_j = ""
        for j in string.gmatch(table_proj[retval], ".") do
          new_str_j = new_str_j .. j
          if get_os == "win" then
            if j == str_sep then
              new_str_j = new_str_j .. str_sep
            end
          end
        end
        
        fileContent[numb_find_2] = "    local last_open_project_directory = " .. "'" ..
        new_str_j .. "'"
      
        file = io.open(inputFile, 'w')
        for index, value in ipairs(fileContent) do
            file:write(value..'\n')
        end
        io.close(file)
      end
        
    end
  end

  local x, y = reaper.GetMousePosition()
  gfx.init("Select a Project...",menu_width_x,menu_width_y,0,x+menu_position_x,y+menu_position_y)
  
  Main()
